#include "catch.hpp"
#include "citoyen.hpp"
#include <stdexcept>
#include <sstream>
#include <cstring>

/*
TEST_CASE("Personne1") {
	  const char * nom = "jacques";
    Personne zz(nom);

    REQUIRE(nom == zz.getNom());
    
    zz.setNom("c");
    
    REQUIRE("c" == zz.getNom());
} */

/*
TEST_CASE("Personne2") {
    const char * nom = "francois";
    const Personne zz(nom);

    REQUIRE(nom     == zz.getNom());
} */

/*
TEST_CASE("Personne3") {
    REQUIRE("INCONNU" == INCONNU.getNom());
}*/

/*
TEST_CASE("Citoyen") {
  const Citoyen chef;
        Citoyen citoyen1;
  const Citoyen citoyen2;

  CHECK  (1 == chef.getId());
  CHECK  (1 == chef.getInfluence());
  
  CHECK  (chef.getId()  +1 == citoyen1.getId());
  CHECK  (1 == citoyen1.getInfluence());
  
  CHECK  (citoyen1.getId()+1 == citoyen2.getId());
  CHECK  (1 == citoyen2.getInfluence());

} */

/*
TEST_CASE("Leader") {
   Citoyen citoyen1; 
   Leader  chef;
   Citoyen citoyen2;

   CHECK( 1 == chef.getInfluence());

   CHECK(   citoyen1.getId()+1 == chef.getId());
   CHECK(chef.getId()+1 == citoyen2.getId());

   chef.inspire(&citoyen1);
   CHECK( 11 == chef.getInfluence());
   chef.inspire(&citoyen2);
   CHECK( 12 == chef.getInfluence());

   Leader boss;
   CHECK( 1 == boss.getInfluence());
   CHECK(citoyen2.getId()+1 == boss.getId());
   boss.inspire(&chef);

   CHECK( 22 == boss.getInfluence());
} */

/*
TEST_CASE("Inconnu") {
  InconnuException inconnu;
  CHECK( strcmp(inconnu.what(), "personnalite inconnue")==0);
}*/


/*
TEST_CASE("Exception") {
  Citoyen inconnu;
  
  REQUIRE_THROWS_AS(inconnu.getPersonne(), InconnuException);
} */

/*
TEST_CASE("Revelation") {
  Citoyen chef;
  const Personne personne("Emmanuel M");
  
  CHECK(! personne.equals(Personne("loic")));

  chef.setPersonne(personne);
  
  CHECK(chef.getPersonne().equals(Personne("Emmanuel M")));
} */

/*
TEST_CASE("Comparaison") {
  Citoyen g1;
  Citoyen g2;
  Leader  c;

  // Citoyen de meme influence => "age" qui compte
  CHECK( g2 < g1 );
  CHECK( c  < g1 );

  
  c.inspire(&g2);
  // Citoyen de plus d'influence
  CHECK( g1  < c );
  CHECK( g2  < c );
} */

/*
void creerFamille(Famille & famille, Citoyen*hommes[]) {
  for (int i = 0; i < 10; ++i) {
    hommes[i] = new Citoyen();
    famille.ajouter(hommes[i]);
  }
  for (int i = 10; i < 13; ++i) {
    hommes[i] = new Leader();
    famille.ajouter(hommes[i]);
  }
  for (int i = 0; i < 5; ++i) {
    ((Leader*)hommes[10])->inspire(hommes[2*i]);
    ((Leader*)hommes[11])->inspire(hommes[2*i+1]);
  }
  ((Leader*)hommes[12])->inspire(hommes[10]);
  ((Leader*)hommes[12])->inspire(hommes[11]);
}

*/

/*
TEST_CASE("Famille1A") {
  Famille famille;
  std::stringstream ss;

  Citoyen * hommes[13];

  creerFamille(famille, hommes);
  
  //const char * tableau[10] = {"Charles", "Alain", "Georges", "Valery", "Lucas", 
                              "Francois", "Jacques", "Nicolas", "FrancoisH",
                              "Emmanuel"};
  const char * tableau[13] = {"Tony", "Clemenza", "Peter", "Kay", "Lucas", 
                              "Salvatore", "Virgil", "Carlo", "Jack",
                              "Moe", "Tom Hagen", "Santino Corleone", "Vito" };

  for(int i =0; i<13; ++i) 
    if (i%4) {
      hommes[i]->setPersonne(Personne(tableau[i]));
      // std::cout << hommes[i]->getPersonne().getNom() << std::endl;
  }

  //famille.listePersonnes(std::cout);
  famille.listePersonnes(ss);

  std::stringstream attendu;
  //attendu << "Alain, Charles, Emmanuel, Francois, FrancoisH, Georges, Jacques, Nicolas, Valery";
  attendu << "Carlo, Clemenza, Kay, Moe, Peter, Salvatore, Santino Corleone, Tom Hagen, Virgil";

  CHECK(attendu.str() == ss.str()); 
  
} */

/*
TEST_CASE("Famille1B") {
  Famille famille;
  std::stringstream ss;

  Citoyen * hommes[13];

  creerFamille(famille, hommes);
  
  //const char * tableau[9] = {"Charles", "Alain", "Georges", "Valery"
                              "Francois", "Jacques", "Nicolas", "FrancoisH",
                              "Emmanuel"};
  const char * tableau[13] = {"Tony", "Clemenza", "Peter", "Kay", "Lucas", 
                              "Salvatore", "Virgil", "Carlo", "Jack",
                              "Moe", "Tom Hagen", "Santino Corleone", "Vito" };
                            
  for(int i =0; i<13; ++i) 
    if (i%4) {
      hommes[i]->setPersonne(Personne(tableau[i]));
  }

  ss << famille;

  std::stringstream attendu;
  //attendu << "Alain, Charles, Emmanuel, Francois, FrancoisH, Georges, Jacques, Nicolas, Valery";
  attendu << "Carlo, Clemenza, Kay, Moe, Peter, Salvatore, Santino Corleone, Tom Hagen, Virgil";

  CHECK(attendu.str() == ss.str()); 

} */

/*
TEST_CASE("Foncteur") {
  Citoyen g1;
  Citoyen g2;
  Leader  c;

  c.inspire(&g1);

  FoncteurInf foncteur;
  CHECK(foncteur(&g2, &g1));
  CHECK(foncteur(&g1, &c ));
} */

/*
TEST_CASE("Famille2") {
  Famille famille;
  std::stringstream ss;
  Citoyen * hommes[13];
  
  creerFamille(famille, hommes);

  // std::cout << std::endl;
  // for(Citoyen * homme : hommes) 
  //   std::cout << homme->getId() << "/" << homme->getInfluence() << " ";
  // std::cout << std::endl;

  // famille.listeMembres(std::cout);
  famille.listeMembres(ss);

  std::stringstream attendu;
  
  attendu << hommes[12]->getId() << " ";
  attendu << hommes[10]->getId() << " ";
  attendu << hommes[11]->getId();
  for(int i =0; i<10; ++i)
    attendu << " " << hommes[i]->getId();
  
  CHECK(attendu.str() == ss.str());
} */

// ET VALGRIND ????